#include <iostream>

using namespace std;

// Uzupelnienie siagu 'str' znakami 'ch' z lewej strony tak, aby nowy ciag mial 'newLength' dlugosci
string PadLeft(string str, int cnt, char ch)
{
	string result = str;
	for(int i=0; i<cnt; i++)
		result = ch + result;
	return result;
}

// Usniecie wszystkich znakow 'ch' z lewj strony ciagu 'str'
string StripLeft(string str, char ch)
{
	string result = str;
	while(result.length()>1 && result[0]==ch)
		result.erase(0, 1);					// Uzycie metody standardowej erase() - usuniecie najbardziej skrajnego znaku po lewej
	return result;
}

// Zamiana cyfry zapisanej jako znak na jej wartosc liczbowa
int DigitToInt(char digit)
{
	if(digit>='0' && digit<='9')		// Cyfry dziesietnie
		return digit - '0';
	else if(digit>='A' && digit<='Z')	// Cyfry szenastkowe zapisane wielkimi literami
		return digit - 'A' + 10;
	else if(digit>='a' && digit<='z')	// Cyfry szenastkowe zapisane malymi literami
		return digit - 'a' + 10;
	else								// Znak niebedacy cyfra
		return 0;
}

char IntToDigit(int value)
{
	if(value>=0 && value<=9)
		return value + '0';
	else if(value>=10 && value <=36)
		return value - 10 + 'A';
	else
		return '0';
}

// Dodawanie dwoch liczb w systemie binarnym
string AddBin(string value1, string value2)
{
	int len1 = value1.length(), len2 = value2.length();
	// Dopasowanie dlugosci - dodanie '0' z przodu w razie potrzeby
	if(len1>len2)
		value2 = PadLeft(value2, len1-len2, '0');
	else if (len2>len1)
		value1 = PadLeft(value1, len2-len1, '0');
	// Dodawanie
	string result = "";
	int carry = 0;					// Wartosc przeniesienia
	for(int i=value1.length()-1; i>=0; i--)
	{
		int sum = DigitToInt(value1[i]) + DigitToInt(value2[i]) + carry;
		carry = sum / 2;
		sum = sum % 2;
		result = IntToDigit(sum) + result;
	}
	result = IntToDigit(carry) + result;
	return StripLeft(result, '0');			// Usuniecie zbednych zer po lewej stronie
}


void TestAdd(string value1, string value2)
{
	string addResult = AddBin(value1, value2);
	int v1 = AnyBaseToDec(value1, 2);
	int v2 = AnyBaseToDec(value2, 2);
	int addv = AnyBaseToDec(addResult, 2);
	bool ok = (v1 + v2 == addv);
	cout << value1 << "+" << value2 << "=" << addResult << "\tKontrola: " <<
		v1 << "+" << v2 << "=" << addv << (!ok ? "\tBLAD!" : "") << endl;
}

int main()
{
	TestAdd("0", "0");
	TestAdd("0", "1");
	TestAdd("1", "0");
	TestAdd("1", "1");
	TestAdd("1010", "1100");
	TestAdd("1010", "0100");
	TestAdd("0100", "1010");
	TestAdd("1010", "100");
	TestAdd("100", "1010");
	TestAdd("1111", "1111");
}
